#!/usr/bin/env node
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));

// src/leetcode-dump.ts
var import_node_path5 = __toESM(require("path"));
var import_chalk2 = __toESM(require("chalk"));
var import_commander = require("commander");
var import_dotenv = require("dotenv");

// src/build.ts
var import_node_child_process = require("child_process");
var import_node_path3 = __toESM(require("path"));
var import_fs_extra = __toESM(require("fs-extra"));

// src/transform.ts
var import_node_fs2 = __toESM(require("fs"));
var import_node_path2 = __toESM(require("path"));

// src/constants.ts
var EXTS = {
  cpp: ".cpp",
  java: ".java",
  python: ".py",
  python3: ".py3",
  c: ".c",
  csharp: ".cs",
  javascript: ".js",
  ruby: ".rb",
  swift: ".swift",
  golang: ".go",
  scala: ".scala",
  kotlin: ".kt",
  rust: ".rs",
  php: ".php",
  typescript: ".ts",
  racket: ".rkt",
  erlang: ".erl",
  elixir: ".ex"
};
var COMMENTS = {
  cpp: "//",
  java: "//",
  python: "#",
  python3: "#",
  c: "//",
  csharp: "//",
  javascript: "//",
  ruby: "#",
  swift: "//",
  golang: "//",
  scala: "//",
  kotlin: "//",
  rust: "//",
  php: "//",
  typescript: "//",
  racket: ";",
  erlang: "%",
  elixir: "#"
};
var LEETCODE_BASE = "https://leetcode.com";
var LEETCODE_DETAIL_BASE = LEETCODE_BASE + "/submissions/detail/";
var LEETCODE_SLUG_BASE = LEETCODE_BASE + "/problems/";
var README_TEMPLATE = `
# LeetCode Solutions

$card

## Solutions

| Problem | Difficulty | Tags | Solution |
| ------- | ---------- | ---- | -------- |
$table
`;
var DOC_TEMPLATE = `---
title: $title
---

# $title

$problem

$note

## Code

$code
`;

// src/utils.ts
var import_node_fs = __toESM(require("fs"));
var import_node_path = __toESM(require("path"));
var import_chalk = __toESM(require("chalk"));
function get_package_meta() {
  return JSON.parse(import_node_fs.default.readFileSync(import_node_path.default.join(__dirname, "../package.json"), "utf8"));
}
function readable_memory(mem) {
  const units = ["B", "KB", "MB", "GB", "TB"];
  let unit = 0;
  while (mem > 1e3) {
    mem /= 1e3;
    unit++;
  }
  return `${mem.toFixed(2)} ${units[unit]}`;
}
function sleep(ms) {
  return new Promise((resolve) => setTimeout(resolve, ms));
}
async function retry(func, max_retry2 = 3, cooldown = 5e3) {
  let error = null;
  for (let retry2 = 0; retry2 < max_retry2; retry2++) {
    try {
      return await func();
    } catch (err) {
      console.error(import_chalk.default.redBright(err));
      error = err;
      await sleep(cooldown);
    }
  }
  throw error;
}
var Logger = class {
  constructor(name = "", verbose = 3) {
    this.name = name;
    this.verbose = verbose;
    if (verbose) {
      this.log(`Verbose Level: ${verbose}`);
    }
  }
  log(...args) {
    if (this.verbose >= 3) {
      console.log(import_chalk.default.gray(`[${this.name}]`), ...args);
    }
  }
  warn(...args) {
    if (this.verbose >= 2) {
      console.warn(import_chalk.default.yellowBright(`[${this.name}]`), ...args);
    }
  }
  error(...args) {
    if (this.verbose >= 1) {
      console.error(import_chalk.default.redBright(`[${this.name}]`), ...args);
    }
  }
};

// src/transform.ts
async function transform(source, output, verbose = false) {
  const logger = new Logger("Transform", verbose ? 3 : 0);
  source = import_node_path2.default.resolve(source);
  output = import_node_path2.default.resolve(output);
  logger.log(`Source: ${source}`);
  logger.log(`Output: ${output}`);
  if (!import_node_fs2.default.existsSync(source)) {
    throw new Error(`[Transform] ${source} does not exist`);
  }
  if (import_node_fs2.default.existsSync(output)) {
    throw new Error(`[Transform] ${output} already exists`);
  }
  try {
    import_node_fs2.default.mkdirSync(output, { recursive: true });
    import_node_fs2.default.writeFileSync(import_node_path2.default.resolve(output, "README.md"), fix(import_node_fs2.default.readFileSync(import_node_path2.default.resolve(source, "README.md"), "utf8")));
    logger.log("Root level README.md written");
    const problems = import_node_fs2.default.readdirSync(source).filter((name) => import_node_fs2.default.statSync(import_node_path2.default.resolve(source, name)).isDirectory());
    logger.log(`${problems.length} problems found`);
    for (const problem of problems) {
      const slug = problem.replace(/(\d+)\./, "$1").replace(/\s+/g, "-").replace("'", "").toLowerCase();
      import_node_fs2.default.mkdirSync(import_node_path2.default.resolve(output, slug), { recursive: true });
      const doc = gen_doc(import_node_path2.default.resolve(source, problem));
      import_node_fs2.default.writeFileSync(import_node_path2.default.resolve(output, slug, "index.md"), doc);
      logger.log(`${problem} written`);
    }
    logger.log("Transform Complete");
  } catch (err) {
    logger.error(err);
  }
}
function gen_doc(src) {
  const title = import_node_path2.default.basename(src);
  const problem = import_node_fs2.default.readFileSync(import_node_path2.default.resolve(src, "README.md"), "utf8");
  const note = import_node_fs2.default.readFileSync(import_node_path2.default.resolve(src, "NOTE.md"), "utf8");
  const sources = import_node_fs2.default.readdirSync(src).filter((name) => !name.endsWith(".md"));
  const solutions = sources.map((name) => {
    const solution = import_node_fs2.default.readFileSync(import_node_path2.default.resolve(src, name), "utf8");
    return { type: import_node_path2.default.extname(name).slice(1), solution };
  });
  return DOC_TEMPLATE.replace(/\$title/g, title).replace(/\$note/g, note).replace(/\$problem/g, problem.replace(/#[^\n]+\n/, "<br>\n\n")).replace(/\$code/g, solutions.map(({ type, solution }) => `### ${type.toUpperCase()}

\`\`\`${type}
${solution}
\`\`\``).join("\n\n"));
}
function fix(source) {
  return source.replace(/\(\.\/\d{1,4}\.[^)]+\)/g, (match) => match.replace(/(\d+)\./, "$1").replace(/(%20)+/g, "-").replace("'", "").toLowerCase()).replace(/([^.]\/)[^.]+\.([\w]+\))/g, "$1#$2");
}

// src/build.ts
async function build(source, output, config2, verbose = false) {
  var _a;
  const logger = new Logger("Build", verbose ? 3 : 0);
  source = import_node_path3.default.resolve(source);
  output = import_node_path3.default.resolve(output);
  logger.log(`Building site to ${output}`);
  if (!import_fs_extra.default.existsSync(source)) {
    throw new Error(`${source} does not exist`);
  }
  const workspace = import_fs_extra.default.mkdtempSync("site-tmp-");
  const tmp = import_node_path3.default.resolve(workspace, "source");
  import_fs_extra.default.symlinkSync(import_node_path3.default.resolve(__dirname, "../node_modules"), import_node_path3.default.resolve(workspace, "node_modules"));
  logger.log("Symlinked node_modules");
  transform(source, tmp, verbose);
  logger.log("Site transformed");
  if (import_fs_extra.default.existsSync(output)) {
    import_fs_extra.default.rmSync(output, { recursive: true });
  }
  const repo = (_a = process.env.GITHUB_ACTION_REPOSITORY) == null ? void 0 : _a.split("/");
  await build_site(workspace, output, __spreadValues({
    plugins: [[require.resolve("@vuepress/plugin-search"), {}]],
    title: "LeetCode Solutions",
    description: `${repo ? repo[0] + "'s" : "My"} LeetCode Solutions`,
    base: repo ? `/${repo[1]}/` : "/"
  }, safe_parse(config2)));
  import_fs_extra.default.rmSync(workspace, { recursive: true });
  logger.log("Build Complete");
}
async function build_site(workspace, dest, config2) {
  const exe = import_node_path3.default.resolve(require.resolve("vuepress"), "../../bin/vuepress.js");
  import_fs_extra.default.mkdirSync(import_node_path3.default.resolve(workspace, "source", ".vuepress"), { recursive: true });
  import_fs_extra.default.writeFileSync(import_node_path3.default.resolve(workspace, "source", ".vuepress", "config.ts"), `export default ${JSON.stringify(config2, null, 4)};`);
  (0, import_node_child_process.execSync)(`${exe} build source --dest site`, { stdio: "inherit", cwd: workspace });
  import_fs_extra.default.moveSync(import_node_path3.default.resolve(workspace, "site"), dest, { overwrite: true });
}
function safe_parse(path6) {
  if (!path6) {
    return void 0;
  }
  try {
    return JSON.parse(import_fs_extra.default.readFileSync(path6, "utf8"));
  } catch {
    return void 0;
  }
}

// src/dump.ts
var import_node_fs3 = __toESM(require("fs"));
var import_node_path4 = __toESM(require("path"));
var import_leetcode_query = require("leetcode-query");
var import_node_fetch = __toESM(require("node-fetch"));
var import_ora = __toESM(require("ora"));
var import_turndown = __toESM(require("turndown"));
var turndown = new import_turndown.default().addRule("pre", {
  filter: "pre",
  replacement: (content, node) => "\n```\n" + node.textContent.replace("```", "\\`\\`\\`").trim() + "\n```\n"
}).addRule("sup", {
  filter: "sup",
  replacement: (content) => `^${content}`
});
var leetcode;
var max_retry = 3;
async function dump({
  session,
  output = import_node_path4.default.resolve("leetcode"),
  clean = false,
  limit = "20/10",
  timezone = "Asia/Taipei",
  pure = false,
  retry: retry2 = 3,
  verbose = true
}) {
  process.env.TZ = timezone;
  max_retry = retry2;
  const dir = import_node_path4.default.resolve(output);
  if (import_node_fs3.default.existsSync(dir) && clean) {
    import_node_fs3.default.rmSync(dir, { recursive: true });
  }
  if (!import_node_fs3.default.existsSync(dir)) {
    import_node_fs3.default.mkdirSync(dir, { recursive: true });
  }
  const cache_path = import_node_path4.default.resolve(dir, ".cache.json");
  const cache = import_node_fs3.default.existsSync(cache_path) ? JSON.parse(import_node_fs3.default.readFileSync(cache_path, "utf8")) : [];
  cache.sort((a, b) => b.id - a.id);
  for (let i = 0; i < cache.length; i++) {
    cache[i].cached = true;
  }
  const config_path = import_node_path4.default.resolve(dir, ".config.json");
  const config2 = import_node_fs3.default.existsSync(config_path) ? JSON.parse(import_node_fs3.default.readFileSync(config_path, "utf8")) : { skip: [] };
  const spinner = verbose ? (0, import_ora.default)({ text: "Scanning...", spinner: "bouncingBar" }).start() : null;
  const credential = new import_leetcode_query.Credential();
  await credential.init(session);
  leetcode = new import_leetcode_query.LeetCode(credential);
  leetcode.limiter.limit = +limit.split("/")[0];
  leetcode.limiter.interval = +limit.split("/")[1] * 1e3;
  const user = await leetcode.whoami();
  if (user.isSignedIn === false) {
    spinner == null ? void 0 : spinner.fail("No user found! Is your session expired?");
    process.exit(1);
  }
  if (cache.length > 0) {
    spinner == null ? void 0 : spinner.info(`Cache Found. Skip scanning submissions before ID ${cache[0].id}`).start();
  }
  if (config2.skip.length > 0) {
    spinner == null ? void 0 : spinner.info(`Config Found. Will skip ${config2.skip.length} submissions`).start();
  }
  const bests = await get_bests({ leetcode, spinner, max_retry, cache, skip: config2.skip });
  spinner == null ? void 0 : spinner.succeed(`Scan Done. (${bests.size} Accepted Problems)`);
  const table = [];
  const entries = bests.entries();
  for (let i = 0; i < bests.size; i++) {
    const [slug, submissions] = entries.next().value;
    spinner == null ? void 0 : spinner.start(`Dumping Submissions... (${i + 1}/${bests.size})`);
    const problem = await leetcode.get_problem(slug);
    spinner && (spinner.text += ` ${problem.questionFrontendId}. ${problem.title} [${[
      ...submissions.keys()
    ].join(", ")}]`);
    const folder = import_node_path4.default.resolve(dir, `${problem.questionFrontendId}. ${problem.title}`);
    if (!import_node_fs3.default.existsSync(folder)) {
      import_node_fs3.default.mkdirSync(folder, { recursive: true });
    }
    import_node_fs3.default.writeFileSync(import_node_path4.default.resolve(folder, "README.md"), `# ${problem.questionFrontendId}. ${problem.title}

Tags: ${problem.topicTags.map((t) => "`" + t.name + "`").join(", ")}

${turndown.turndown(problem.content)}`);
    import_node_fs3.default.writeFileSync(import_node_path4.default.resolve(folder, "NOTE.md"), problem.note || "");
    const row = [
      `[${problem.questionFrontendId}. ${problem.title}](./${encodeURI(import_node_path4.default.basename(folder))}) [\u{1F517}](${LEETCODE_SLUG_BASE}${slug}/)`,
      problem.difficulty,
      problem.topicTags.map((t) => "`" + t.name + "`").join(", "),
      []
    ];
    for (const [lang, meta] of submissions) {
      const ext = EXTS[lang];
      const file = import_node_path4.default.resolve(folder, `${slug}${ext}`);
      if (!meta.cached) {
        const submission = await get_submission(meta.id);
        const info = `${COMMENTS[lang]} ${problem.questionFrontendId}. ${problem.title} (${new Date(+meta.timestamp * 1e3).toLocaleDateString()})
${COMMENTS[lang]} Runtime: ${submission.runtime} ms (${submission.runtime_percentile.toFixed(2)}%) Memory: ${readable_memory(submission.memory)} (${submission.memory_percentile.toFixed(2)}%) 

`;
        import_node_fs3.default.writeFileSync(file, `${pure ? "" : info}${submission.code}`);
      }
      row[3].push(`[${lang}](${encodeURI(`./${import_node_path4.default.basename(folder)}/${slug}${ext}`)})`);
    }
    row[3].sort();
    table.push(row);
    spinner == null ? void 0 : spinner.succeed(`Dumped ${problem.questionFrontendId}. ${problem.title} [${[...submissions.keys()].join(", ")}]`);
  }
  spinner == null ? void 0 : spinner.succeed("All Submissions Dumped.");
  import_node_fs3.default.writeFileSync(import_node_path4.default.resolve(dir, "README.md"), await create_toc(table, user));
  import_node_fs3.default.writeFileSync(cache_path, JSON.stringify([...bests.values()].reduce((acc, subs) => [...acc, ...subs.values()], []).sort((a, b) => b.id - a.id)));
}
async function get_submission(id) {
  return await retry(async () => {
    var _a;
    const res = await (0, import_node_fetch.default)(`${LEETCODE_DETAIL_BASE}${id}/`, {
      headers: {
        Cookie: `LEETCODE_SESSION=${leetcode.credential.session}`,
        Referer: LEETCODE_BASE
      }
    });
    const raw = await res.text();
    const data = (_a = raw.match(/var pageData = ({[^]+?});/)) == null ? void 0 : _a[1];
    const json = new Function("return " + data)();
    const result = {
      runtime: +json.runtime,
      runtime_distribution: json.runtimeDistributionFormatted ? JSON.parse(json.runtimeDistributionFormatted).distribution.map((item) => [+item[0], item[1]]) : null,
      runtime_percentile: 0,
      memory: +json.memory,
      memory_distribution: json.memoryDistributionFormatted ? JSON.parse(json.memoryDistributionFormatted).distribution.map((item) => [+item[0], item[1]]) : null,
      memory_percentile: 0,
      code: json.submissionCode
    };
    if (result.runtime_distribution) {
      result.runtime_percentile = result.runtime_distribution.reduce((acc, [usage, p]) => acc + (usage >= result.runtime ? p : 0), 0);
    }
    if (result.memory_distribution) {
      result.memory_percentile = result.memory_distribution.reduce((acc, [usage, p]) => acc + (usage >= result.memory / 1e3 ? p : 0), 0);
    }
    return result;
  }, max_retry);
}
async function create_toc(table, user) {
  const card = `[![LeetCode Stats Card](https://leetcode.card.workers.dev/?username=${user.username})](https://leetcode.com/${user.username}/)`;
  const table_str = table.map(([title, difficulty, tags, solutions]) => `| ${title} | ${difficulty} | ${tags} | ${solutions.join(" \\| ")} |`).join("\n");
  return README_TEMPLATE.replace("$card", card).replace("$table", table_str);
}
async function get_bests({
  leetcode: leetcode2,
  spinner,
  max_retry: max_retry2,
  cache,
  skip
}) {
  var _a, _b;
  const bests = /* @__PURE__ */ new Map();
  const set = /* @__PURE__ */ new Set();
  const skips = new Set(skip);
  for (const submission of cache) {
    if (!bests.has(submission.titleSlug)) {
      bests.set(submission.titleSlug, /* @__PURE__ */ new Map());
    }
    if (!skips.has(submission.id)) {
      (_a = bests.get(submission.titleSlug)) == null ? void 0 : _a.set(submission.lang, submission);
      set.add(submission.id);
    }
  }
  const prev_last = ((_b = cache[0]) == null ? void 0 : _b.id) || 0;
  for (let i = 0; i < 1e3; i++) {
    const submissions = await retry(() => leetcode2.get_submissions({ limit: 20, offset: i * 20 }), max_retry2);
    if (submissions.every((submission) => set.has(submission.id))) {
      break;
    }
    for (const submission of submissions) {
      if (!set.has(submission.id) && !skips.has(submission.id) && submission.id > prev_last) {
        set.add(submission.id);
        if (submission.statusDisplay === "Accepted") {
          if (bests.has(submission.titleSlug) === false) {
            bests.set(submission.titleSlug, /* @__PURE__ */ new Map());
          }
          const best = bests.get(submission.titleSlug);
          const prev = best.get(submission.lang);
          if (prev === void 0 || submission.runtime < prev.runtime || submission.runtime === prev.runtime && submission.timestamp > prev.timestamp) {
            best.set(submission.lang, submission);
          }
        }
      }
    }
    if (spinner) {
      spinner.text = `Scanning... ${set.size} submissions fetched`;
    }
    if (submissions.length < 20 || submissions[submissions.length - 1].id <= prev_last) {
      break;
    }
  }
  return bests;
}

// src/leetcode-dump.ts
(0, import_dotenv.config)();
var package_meta = get_package_meta();
import_commander.program.version(import_chalk2.default`{cyanBright ${package_meta.name}} {yellowBright v${package_meta.version}}`);
import_commander.program.enablePositionalOptions().option("-s, --session <session>", "Your LeetCode Session", process.env.LEETCODE_SESSION || "process.env.LEETCODE_SESSION").option("-o, --output <path>", "Output Dir", import_node_path5.default.resolve("leetcode")).option("-c, --clean", "Clear Output Dir Before Start", false).option("-l, --limit <rate>", "Rate Limit <req>/<sec>", "20/10").option("-t, --timezone <timezone>", "Your Timezone", "Asia/Taipei").option("-p, --pure", "Pure Mode, No Additional Informations to Add", false).option("-r, --retry <times>", "Times to Retry When Fail", "3").option("-v, --verbose [bool]", "Verbose Mode", true).action(async () => {
  const opts = import_commander.program.opts();
  await dump({
    session: opts.session,
    output: opts.output,
    clean: opts.clean,
    limit: opts.limit,
    timezone: opts.timezone,
    pure: opts.pure,
    retry: +opts.retry,
    verbose: opts.verbose
  });
});
var build_command = import_commander.program.command("build").description("Build static site from dumped solutions").option("-s, --source <path>", "Source Dir", import_node_path5.default.resolve("leetcode")).option("-o, --output <path>", "Output Dir", import_node_path5.default.resolve("site")).option("-c, --config <path>", "Vuepress Config Path", void 0).option("-v, --verbose [bool]", "Verbose Mode", true).action(() => {
  const opts = build_command.opts();
  build(opts.source, opts.output, opts.config, opts.verbose);
});
var transform_command = import_commander.program.command("transform").description("Transform dumped solutions to a Vuepress source").option("-s, --source <path>", "Source Dir", import_node_path5.default.resolve("leetcode")).option("-o, --output <path>", "Output Dir", import_node_path5.default.resolve("site-source")).option("-v, --verbose [bool]", "Verbose Mode", true).action(() => {
  const opts = transform_command.opts();
  transform(opts.source, opts.output, opts.verbose);
});
import_commander.program.parse();
